// Test.java
import java.io.*;
import java.util.*;

public class Test {
    public static void main(String[] args) throws Exception {
        String text = args[0];
        System.out.println("input: " + text);
        
        ExpressionParser p = new ExpressionParser();
        ExpressionParser.Node expr = p.parseExpression("test", text, 8);
        dump("", expr);
    }
    public static void dump(String indent, ExpressionParser.Node node) {
        if (node instanceof ExpressionParser.Token) {
            ExpressionParser.Token token = (ExpressionParser.Token) node;
            System.out.println(indent + token.getImage());
        } else {
            String className = node.getClass().getName();
            System.out.println(indent + className);
            
            Iterator it = node.getChildNodes().iterator();
            while (it.hasNext()) {
                ExpressionParser.Node child = (ExpressionParser.Node) it.next();
                dump(indent + "  ", child);
            }
        }
    }
}
